﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Calculator
{
    public class CalcResult
    {
        const double dSmallestNumber = 0.00000000001;
        const double dMaximumNumber = 999999999.0;
        double      m_Memory;
        string      m_InputString;
        string      m_LastResult;
        double[]    m_dInput = new double[2];
        char[]      m_Opration = new char[2];
	    ushort	    m_OprLevel;
        char        m_LastOpration;
        bool        m_bReadyToRest;
        int         m_nError;
        int         m_nMRCpressed;

        public CalcResult()
        {
            m_dInput[0] = 0;
            m_dInput[1] = 0;
            m_Opration[0] = '0';
            m_Opration[1] = '0';
            m_OprLevel = 0;
            m_LastOpration = '0';
            m_bReadyToRest = true;
            m_LastResult = "";
            m_nError = 0;
            m_Memory = 0.0;
            m_nMRCpressed = 0;
        }

        public string MemoryMRC()
        {
            if (m_Memory == 0)
            {
                return "0.";
            }
            m_nMRCpressed++;
            if (m_nMRCpressed == 1)
            {
                string strResult = string.Format("{0:G8}", m_Memory);
                int DecimalIndex = strResult.IndexOf('.');
                if (DecimalIndex == -1)
                    strResult += ".";
                return strResult;
            }
            
            m_nMRCpressed = 0;
            m_Memory = 0;
            return "0.";          
        }
        public double GetMemory()
        {
            return m_Memory;
        }

        public void MemoryPlus()
        {
            double dNewInput = ( m_InputString == null || m_InputString.Length == 0) ? 0 : Convert.ToDouble(m_InputString);
            if (m_LastOpration == '=')
                dNewInput = Convert.ToDouble(m_LastResult);
            m_Memory += dNewInput;
            m_bReadyToRest = true;
        }

        public void MemoryMinus()
        {
            double dNewInput = (m_InputString == null || m_InputString.Length == 0) ? 0 : Convert.ToDouble(m_InputString);
            if (m_LastOpration == '=')
               dNewInput = Convert.ToDouble(m_LastResult);
                        
            m_Memory -= dNewInput;
            m_bReadyToRest = true;
        }

        public string KeyPressed(char Key)
        {
            if (m_nError == 1)
                return "Devide by zero";
            else if (m_nError == 2)
                return "Out of range";

            m_nMRCpressed = 0;
            if (m_bReadyToRest)
                m_InputString = "";
            m_bReadyToRest = false;
           
            m_LastOpration = '0';
            int nLen = m_InputString.Length;

            int DecIndex = m_InputString.IndexOf('.');
            if ((DecIndex != -1 && Key == '.') || nLen >= 10 || (nLen == 0 && Key == '0') || (DecIndex == -1 && nLen >= 9))
            {
                return "0.";
            }

            if (nLen == 0 && Key == '.')
                m_InputString = "0.";
            else
                m_InputString += Key;

          DecIndex = m_InputString.IndexOf('.');
          string strdisplay = (DecIndex == -1) ? m_InputString + '.' : m_InputString;
          return strdisplay;

        }

        
        public string EqualKeyPressed() 
        {
            if (m_nError == 1)
                return "Devide by zero";
            else if (m_nError == 2)
                return "Out of range";
            
            m_nMRCpressed = 0;

            if (m_OprLevel == 0)
            {
                int DecIndex = m_InputString.IndexOf('.');
                string strdisplay = (DecIndex == -1) ? m_InputString + '.' : m_InputString;
                return strdisplay;
            }

            double dNewInput = m_InputString.Length == 0 ? 0 : Convert.ToDouble(m_InputString);
	        if (m_OprLevel == 1)
		        m_dInput[1] = dNewInput;

	        if (m_OprLevel == 2)
	        {
		        if (m_Opration[0] == '*')
		        {
			        m_dInput[0] *= m_dInput[1];
			        m_dInput[1]  = dNewInput;
			        m_OprLevel = 1;
			        m_Opration[0] = m_Opration[1];
		        }else if (m_Opration[0] == '/')
		        {
                    if (Math.Abs(m_dInput[1]) > dSmallestNumber)
			        {
				        m_dInput[0] /= m_dInput[1];
				        m_dInput[1]  = dNewInput;
				        m_OprLevel = 1;
				        m_Opration[0] = m_Opration[1];
			        }else
			        {
                        m_nError = 1;
                        return "Divide by zero";
                    }
		        }else if (m_Opration[1] == '*')
		        {
			        m_dInput[1] *= dNewInput;
			        m_OprLevel = 1;
		        }else if (m_Opration[1] == '/')
		        {
                    if (Math.Abs(dNewInput) > dSmallestNumber)
			        {
				        m_dInput[1] /= dNewInput;
				        m_OprLevel = 1;
			        }else
			        {
                        m_nError = 1;
                        return "Divide by zero";
        				
			        }
		        }else if (m_Opration[1] == '+')
		        {
			        m_dInput[1] += dNewInput;
			        m_OprLevel = 1;
		        }else if (m_Opration[1] == '-')
		        {
			        m_dInput[1] -= dNewInput;
			        m_OprLevel = 1;
		        }
	        }

            switch (m_Opration[0])
	        {
		        case '*':
			        m_dInput[0] *= m_dInput[1];
			        break;
		        case '/':
			        if (Math.Abs(m_dInput[1]) > dSmallestNumber)
				        m_dInput[0] /= m_dInput[1];
			        else
			        {
                        m_nError = 1;
				        return "Divide by zero";
			        }
			        break;
		        case '+':
			        m_dInput[0] += m_dInput[1];
			        break;
		        case '-':
			        m_dInput[0] -= m_dInput[1];
			        break;
	        }

            if (m_dInput[0] > dMaximumNumber)
	        {
                m_nError = 2;
                return "Out of range";

	        }

            string strResult = string.Format("{0:G8}", m_dInput[0]);

            int DecimalIndex = strResult.IndexOf('.');
            if (DecimalIndex == -1)
                strResult += ".";


             do
             {
                 int Length = strResult.Length;
                 if (strResult[Length - 1] == '0' && strResult[Length - 2] == '0')
                     strResult = strResult.Substring(0, Length - 1);
                 else
                     break;

             }while(true);
            
	        ClearData();
            m_LastOpration = '=';
            m_LastResult = strResult;
            return strResult;
        }
         public string Clear()
         {
             ClearData();
             m_nError = 0;
             return "0.";
         }
        void ClearData()
        {
	        m_dInput[0] = 0;
	        m_dInput[1] = 0;
	        m_Opration[0] = '0';
	        m_Opration[1] = '0';
	        m_OprLevel = 0;
	        m_LastOpration = '0';
	        m_bReadyToRest = true;
            m_LastResult = "";
            m_nMRCpressed = 0;
        }

        public string Percent()
        {
            if (m_InputString == null || m_InputString.Length == 0 || m_OprLevel == 0)
                return "0.";

            m_nMRCpressed = 0;
            double percent = Convert.ToDouble(m_InputString);
            double dResult = m_dInput[m_OprLevel - 1] * percent / 100;
            m_InputString = string.Format("{0:G8}", dResult);

            string strReturn = m_InputString;
            int DecimalIndex = strReturn.IndexOf('.');
            if (DecimalIndex == -1)
                strReturn += ".";
            return strReturn;  
        }

        public string SquareRoot()
        {

            m_nMRCpressed = 0;
            if (this.m_LastOpration == '=')
            {
                m_InputString = this.m_LastResult;
            }
            if (m_InputString == null || m_InputString.Length == 0)
                return "0.";

            if (m_InputString[0] == '-')
            {
                m_nError = 3;
                return "Root of -ve";
            }
            double dResult = Convert.ToDouble(m_InputString);

            dResult = Math.Sqrt(dResult);
            m_InputString = string.Format("{0:G8}", dResult);
            if (this.m_LastOpration == '=')
            {
                m_LastResult = m_InputString;
            }

            string strReturn = m_InputString;
            int DecimalIndex = strReturn.IndexOf('.');
            if (DecimalIndex == -1)
                strReturn += ".";
            m_bReadyToRest = true;
            return strReturn;             
        }

        public string ChangeSign()
        {

            m_nMRCpressed = 0;
            if (m_LastOpration == '=')
                m_InputString = m_LastResult;

            if (m_InputString.Length != 0)
            {
                if (m_InputString[0] == '-')
                    m_InputString = m_InputString.Substring(1);
                else
                    m_InputString = "-" + m_InputString;
                if (m_LastOpration == '=')
                    m_LastResult = m_InputString;
            }

            string strReturn = m_InputString;
            int DecimalIndex = strReturn.IndexOf('.');
            if (DecimalIndex == -1)
                strReturn += ".";
            return strReturn;
        }

        public void Calculate(char Opration)
        {
            if (m_nError != 0)
                return;


            m_nMRCpressed = 0;
            if (m_LastOpration == '=')
                m_InputString = m_LastResult;

            double dNewInput = Convert.ToDouble(m_InputString);
            if (m_OprLevel == 0)
            {
                m_dInput[0] = dNewInput;
                m_Opration[0] = Opration;
                m_OprLevel = 1;
            }else if (m_OprLevel == 1)
            {
                if (Opration == '+' || Opration == '-') 
                {
	                if (m_Opration[0] == '+')
		                m_dInput[0] += dNewInput;
	                else if (m_Opration[0] == '-')
		                m_dInput[0] -= dNewInput;
	                else if (m_Opration[0] == '*')
		                m_dInput[0] *= dNewInput;
                    else if (Math.Abs(dNewInput) > dSmallestNumber)
                        m_dInput[0] /= dNewInput;
                    else
                    {
                        m_nError = 1;
                        return;
                    }
	                m_Opration[0] = Opration;
                }else
                {
	                m_OprLevel = 2;
	                m_dInput[1] = dNewInput;
	                m_Opration[1] = Opration;
                }
            }else if (m_OprLevel == 2)
            {
                if (m_Opration[0] == '*' || m_Opration[0] == '/')
                {
	                if (m_Opration[0] == '*')
		                m_dInput[0] *= m_dInput[1];
	                else if (Math.Abs(m_dInput[1]) > dSmallestNumber)
		                m_dInput[0] /= m_dInput[1];
	                else
	                {
                        m_nError = 1;
                        return;
                    }
	                m_dInput[1] = dNewInput;
	                m_Opration[0] = m_Opration[1];
	                m_Opration[1] = Opration;

                }else if (m_Opration[1] == '*' || m_Opration[1] == '/')
                {
	                if (m_Opration[1] == '*')
		                m_dInput[1] *= dNewInput;
                    else if (Math.Abs(dNewInput) > dSmallestNumber)
		                m_dInput[1] /= dNewInput;
	                else
	                {
                        m_nError = 1;
                        return;
                    }
	                m_Opration[1] = Opration;
                }else
                { // Look for -ve opration first;

	                if (m_Opration[0] == '+' && m_Opration[1] == '-')
	                {
		                m_dInput[1] -= dNewInput;
	                }else if (m_Opration[0] == '-' && m_Opration[1] == '+')
	                {
		                m_dInput[0] -= m_dInput[1];
		                m_dInput[1] = dNewInput;
		                m_Opration[0] = '+';
	                }else 
	                {
		                if (m_Opration[1] == '+')
			                m_dInput[1] += dNewInput;
		                else
			                m_dInput[1] -= dNewInput;
	                }
	                m_Opration[1] = Opration;
                }
            }
            m_LastOpration = Opration;
            m_bReadyToRest = true;
        }
    }
}
